Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4893)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! revised output of surface data via MPI-IO for better performance
+!
+! 4876 2021-02-17 12:27:36Z raasch
 ! bugfix for instantaneous c_liq output
 !
@@ -6249,5 +6252,6 @@
     INTEGER(iwp)      ::  l      !< index variable for surface orientation
 
-    INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< index for surface data (MPI-IO)
+    INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_end_index    !< end index for surface data (MPI-IO)
+    INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< start index for surface data (MPI-IO)
 
     LOGICAL ::  surface_data_to_write  !< switch for MPI-I/O if PE has surface data to write
@@ -6435,14 +6439,14 @@
 
           CALL rd_mpi_io_surface_filetypes( surf_lsm_h(l)%start_index, surf_lsm_h(l)%end_index,    &
-                                            surface_data_to_write, global_start_index )
-
-          CALL wrd_mpi_io( 'lsm_start_index_h_' // dum,  surf_lsm_h(l)%start_index )
-          CALL wrd_mpi_io( 'lsm_end_index_h_' // dum,  surf_lsm_h(l)%end_index )
+                                            surface_data_to_write, global_start_index,             &
+                                            global_end_index )
+
           CALL wrd_mpi_io( 'lsm_global_start_index_h_' // dum, global_start_index )
+          CALL wrd_mpi_io( 'lsm_global_end_index_h_' // dum, global_end_index )
 
           IF ( .NOT. surface_data_to_write )  CYCLE
 
           CALL wrd_mpi_io_surface( 't_soil_h(' // dum // ')', t_soil_h(l)%var_2d )
-          CALL wrd_mpi_io_surface( 'm_soil_h(' // dum // ')',  m_soil_h(l)%var_2d )
+          CALL wrd_mpi_io_surface( 'm_soil_h(' // dum // ')', m_soil_h(l)%var_2d )
           CALL wrd_mpi_io_surface( 'm_liq_h(' // dum // ')', m_liq_h(l)%var_1d )
           CALL wrd_mpi_io_surface( 't_surface_h(' // dum // ')', t_surface_h(l)%var_1d )
@@ -6454,9 +6458,9 @@
 
           CALL rd_mpi_io_surface_filetypes ( surf_lsm_v(l)%start_index, surf_lsm_v(l)%end_index,   &
-                                             surface_data_to_write, global_start_index )
-
-          CALL wrd_mpi_io( 'lsm_start_index_v_' // dum,  surf_lsm_v(l)%start_index )
-          CALL wrd_mpi_io( 'lsm_end_index_v_' // dum,  surf_lsm_v(l)%end_index )
-          CALL wrd_mpi_io( 'lsm_global_start_index_v_' // dum , global_start_index )
+                                            surface_data_to_write, global_start_index,             &
+                                            global_end_index )
+
+          CALL wrd_mpi_io( 'lsm_global_start_index_v_' // dum, global_start_index )
+          CALL wrd_mpi_io( 'lsm_global_end_index_v_' // dum, global_end_index )
 
           IF ( .NOT. surface_data_to_write )  CYCLE
@@ -7133,10 +7137,9 @@
     INTEGER(iwp) ::  l   !< running index surface orientation
 
-    !INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  end_index
-    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_start
-    !INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  start_index
-
-    LOGICAL      :: array_found
-    LOGICAL      :: ldum
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_end_index
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index
+
+    LOGICAL ::  array_found
+    LOGICAL ::  data_to_read    !< switch to steer reading of data
 
 
@@ -7205,12 +7208,13 @@
        WRITE( dum, '(I1)')  l
 
-       CALL rrd_mpi_io( 'lsm_start_index_h_' // dum,  surf_lsm_h(l)%start_index )
-       CALL rrd_mpi_io( 'lsm_end_index_h_' // dum,  surf_lsm_h(l)%end_index )
-       CALL rrd_mpi_io( 'lsm_global_start_index_h_' // dum, global_start )
-
-       CALL rd_mpi_io_surface_filetypes ( surf_lsm_h(l)%start_index, surf_lsm_h(l)%end_index, ldum,&
-                                          global_start )
-
-       IF ( MAXVAL( surf_lsm_h(l)%end_index ) <= 0 )  CYCLE
+!
+!--    surf_lsm_h(l)%start_index and surf_lsm_h(l)%end_index are already set and should not be read
+!--    from restart file.
+       CALL rrd_mpi_io( 'lsm_global_start_index_h_' // dum, global_start_index )
+       CALL rrd_mpi_io( 'lsm_global_end_index_h_' // dum, global_end_index )
+
+       CALL rd_mpi_io_surface_filetypes ( surf_lsm_h(l)%start_index, surf_lsm_h(l)%end_index,      &
+                                          data_to_read, global_start_index, global_end_index )
+       IF ( .NOT. data_to_read )  CYCLE
 
        CALL rrd_mpi_io_surface( 't_soil_h(' // dum // ')', t_soil_h(l)%var_2d )
@@ -7218,4 +7222,5 @@
        CALL rrd_mpi_io_surface( 'm_liq_h(' // dum // ')', m_liq_h(l)%var_1d )
        CALL rrd_mpi_io_surface( 't_surface_h(' // dum // ')', t_surface_h(l)%var_1d )
+
     ENDDO
 
@@ -7224,17 +7229,13 @@
        WRITE( dum, '(I1)')  l
 
-!kk    In case of nothing to do, the settings of start_index and end_index differ
-!kk    between writing and reading restart file
-!kk
-!kk    Has to be discussed with the developers
-
-       CALL rrd_mpi_io( 'lsm_start_index_v_' // dum,  surf_lsm_v(l)%start_index )
-       CALL rrd_mpi_io( 'lsm_end_index_v_' // dum,  surf_lsm_v(l)%end_index )
-       CALL rrd_mpi_io( 'lsm_global_start_index_v_' // dum , global_start )
-
-       CALL rd_mpi_io_surface_filetypes( surf_lsm_v(l)%start_index, surf_lsm_v(l)%end_index, ldum, &
-                                         global_start )
-
-       IF ( MAXVAL( surf_lsm_v(l)%end_index ) <= 0 )  CYCLE
+!
+!--    surf_lsm_v(l)%start_index and surf_lsm_v(l)%end_index are already set and should not be read
+!--    from restart file.
+       CALL rrd_mpi_io( 'lsm_global_start_index_v_' // dum , global_start_index )
+       CALL rrd_mpi_io( 'lsm_global_end_index_v_' // dum , global_end_index )
+
+       CALL rd_mpi_io_surface_filetypes( surf_lsm_v(l)%start_index, surf_lsm_v(l)%end_index,       &
+                                         data_to_read, global_start_index, global_end_index )
+       IF ( .NOT. data_to_read )  CYCLE
 
        CALL rrd_mpi_io_surface( 't_soil_v(' // dum // ')', t_soil_v(l)%var_2d )
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4893)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! revised output of surface data via MPI-IO for better performance,
+! therefore binary version number has changed
+!
+! 4848 2021-01-21 15:51:51Z gronemeier
 ! bugfix: removed syn_turb_gen from restart files
 !
@@ -276,4 +280,10 @@
     CALL location_message( 'read global restart data', 'start' )
 
+!
+!-- Caution: When any of the read instructions have been changed, the
+!-- -------  version number stored in the variable binary_version_global has
+!--          to be increased. The same changes must also be done in wrd_write_global.
+    binary_version_global = '5.3'
+
     IF ( TRIM( restart_data_format_input ) == 'fortran_binary' )  THEN
 !
@@ -286,5 +296,4 @@
        READ ( 13 )  version_on_file
 
-       binary_version_global = '5.2'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version_global ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning ',           &
@@ -373,8 +382,5 @@
 !
 !--    Now read all control parameters:
-!--    Caution: When the following read instructions have been changed, the
-!--    -------  version number stored in the variable binary_version_global has
-!--             to be increased. The same changes must also be done in
-!--             wrd_write_global.
+
        READ ( 13 )  length
        READ ( 13 )  restart_string(1:length)
@@ -873,8 +879,5 @@
 !--    Read global restart data using MPI-IO
 !--    ATTENTION: Arrays need to be read with routine rrd_mpi_io_global_array!
-!--    Caution: When any of the following read instructions have been changed, the
-!--    -------  version number stored in the variable binary_version_global has
-!--             to be increased. The same changes must also be done in
-!--             wrd_write_global.
+
 !
 !--    Open the MPI-IO restart file.
@@ -886,5 +889,4 @@
        CALL rrd_mpi_io( 'binary_version_global',  version_on_file )
 
-       binary_version_global = '5.1'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version_global ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning binary_version_global:',         &
